
Figure - Bug #116849
测试 Test-IT # 110867 (New): V1.0测试功能汇总

测试 Test-IT # 110895 (New): AF-V1.0功能测试-桌面

【AF】【EVT】【桌面】在测试过程中，屏幕短时间卡住，弹窗提示系统桌面未响应，直接重启（偶现）
2023-03-09 18:00 - CDTS_Test 吴诗雨

Status: CLOSED Start date: 2023-03-09

Priority: Normal Due date: 2023-04-10

Assignee: CDTS_Test 吴诗雨 % Done: 100%

Category: CD-APP Estimated time: 0.00 hour

Target version: VC1_FSE_0090_20230411

Need_Info: -- Found Version: FlatBuild_HH_MCE_FSE.M.R.user.01.00.0078.C101

Resolution: FIXED Degrated: No

Severity: Minor Verified Version:

Reproducibility: Rarely Fixed Version: 2023-04-11

Test Type: ST Root cause: 编码问题

Description

【前提条件】

1、设备已开机

【测试步骤】

1、正常使用过程中

【预期结果】

1、正常使用

【实际结果】

1、屏幕短时间卡住，弹窗提示系统桌面未响应，直接重启

Related issues:

Related to Figure - Bug # 116826: 【AF】【EVT】【系统手势】【偶现一次】副屏... CLOSED 2023-03-09 2023-04-10

History

#1 - 2023-03-21 15:05 - CD APP-王营

- Status changed from New to ASSIGNED

- % Done changed from 0 to 20

■ Current conclusion

问题已定位，修改中

■ My analysis

从Log中分析可知Launcher发生ANR，具体trace文件如下：

"main" prio=5 tid=1 Native  | group="main" sCount=1 ucsCount=0 flags=1 obj=0x71b79fc8 self=0xb400006e67253010  | sysTid=2497 nice=0 cgrp=default sched=0/0

handle=0x7030f654f8  | state=D schedstat=( 12942284435 5638338404 41722 ) utm=977 stm=316 core=4 HZ=100  | stack=0x7fc59a8000-0x7fc59aa000 stackSize=8188KB  |

held mutexes=

  native: #00 pc 00000000000a1dac  /apex/com.android.runtime/lib64/bionic/libc.so (fsync+12)

  native: #01 pc 000000000000475c  /apex/com.android.art/lib64/libopenjdkjvm.so (JVM_Sync+24)

  native: #02 pc 000000000001f428  /apex/com.android.art/lib64/libopenjdk.so (FileDescriptor_sync+44)

  at java.io.FileDescriptor.sync(Native method)

  at android.os.FileUtils.sync(FileUtils.java:256)

  at android.app.SharedPreferencesImpl.writeToFile(SharedPreferencesImpl.java:807)
  at android.app.SharedPreferencesImpl.access$900(SharedPreferencesImpl.java:59)

  at android.app.SharedPreferencesImpl$2.run(SharedPreferencesImpl.java:672)

  - locked <0x0cdf8c6e> (a java.lang.Object)

  at android.app.SharedPreferencesImpl.enqueueDiskWrite(SharedPreferencesImpl.java:691)

  at android.app.SharedPreferencesImpl.access$100(SharedPreferencesImpl.java:59)

  at android.app.SharedPreferencesImpl$EditorImpl.commit(SharedPreferencesImpl.java:604)

  at com.android.launcher3.util.SpUtils.putString(SpUtils.java:40)

  at com.android.launcher3.util.MCUUtil.saveLastActivity(MCUUtil.java:57)

  at com.android.launcher3.util.ActivityChangeReceiver.onReceive(ActivityChangeReceiver.java:15)

  at android.app.LoadedApk$ReceiverDispatcher$Args.lambda$getRunnable$0$LoadedApk$ReceiverDispatcher$Args(LoadedApk.java:1679)

  at android.app.LoadedApk$ReceiverDispatcher$Args$$ExternalSyntheticLambda0.run(unavailable:-1)

  at android.os.Handler.handleCallback(Handler.java:938)

  at android.os.Handler.dispatchMessage(Handler.java:99)

  at android.os.Looper.loopOnce(Looper.java:201)

  at android.os.Looper.loop(Looper.java:288)

  at android.app.ActivityThread.main(ActivityThread.java:7880)

  at java.lang.reflect.Method.invoke(Native method)

  at com.android.internal.os.RuntimeInit$MethodAndArgsCaller.run(RuntimeInit.java:548)

  at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:1009)

1、从以上log中可知，SharedPreference在写文件时候editor使用了commit方法，此方法为同步方法，同时代码中使用了Runtime.getRuntime().exec("sync"); 强

制写入磁盘，此方案是早期MCU断电逻辑中为了保证Activity存写，此处频繁同步写入数据出现ANR问题。

2、当前过压保护方案不需要同步保存Activity，所以取消强制写入磁盘，同时SharedPreference保存数据使用apply异步保存方式。

■ Next action

1、SharedPreference保存数据使用apply方法。

2、取消强制写入磁盘数据方法。

#2 - 2023-03-22 14:35 - CD APP-王营

- Due date set to 2023-03-22

- % Done changed from 20 to 50

- Resolution changed from -- to FIXED

- Fixed Version set to 2023-03-23

- Root cause set to 编码问题

■ Current conclusion

代码已提交，待验证

■Submit URL

https://dev.thundercomm.com/gerrit/c/general/platform/packages/apps/Launcher3/+/188893

#3 - 2023-03-23 14:44 - CDTS_TEST 王成

- Target version set to VC1_FSE_0090_20230411

#4 - 2023-03-27 10:29 - CD APP-王营

- Due date changed from 2023-03-22 to 2023-03-31

无响应ANR问题已经解决提交，目前存在上滑手势失效的问题，正在分析中。
#5 - 2023-04-03 11:46 - CD APP-王营

- Due date changed from 2023-03-31 to 2023-04-07

#6 - 2023-04-10 10:38 - CD APP-王营

- Due date changed from 2023-04-07 to 2023-04-10

当前的进度：

1、分析手势异常原因。

下一步AI：

1、梳理手势inputConsumer的构建机制和生效时机。

#7 - 2023-04-10 20:30 - CD APP-王营

■ Current conclusion

ANR问题已解决，优先入库，过压保护触发后拉起Activity，目前系统自带应用手势正常，测试中微信和QQ会出现手势失效的问题，后面新起一个bug来

跟进手势问题。

■Submit URL

https://dev.thundercomm.com/gerrit/c/general/platform/packages/apps/Launcher3/+/188893

#8 - 2023-04-10 20:37 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

188893 general/platform/packages/apps/Launc

her3

Pre_figure_turbox-c2130c-la1.1-qssi12

-dev

ying.wang@thundersoft.com

AF: Launcher: Fix Launcher ANR1.Fix Launcher ANR when save last activity.TC-RID: 1201-0205301IssueID: TS-R-BUG-116849Change-Id:

Ie98ea2393e353fc74c3b31b24ac2ac0e814b6855

#9 - 2023-04-10 20:38 - CD APP-王营

- Status changed from ASSIGNED to RESOLVED

- Assignee changed from CD APP-王营 to CDTS_Test 吴诗雨

- % Done changed from 50 to 100

- Degrated changed from -- to No

- Fixed Version changed from 2023-03-23 to 2023-04-11

#10 - 2023-04-14 14:44 - CDTS_Test 吴诗雨

验证版本：0414DB

未复现以上情况

#11 - 2023-04-17 15:53 - CDTS_Test 吴诗雨

验证版本：0417DB
验证情况：未复现

#12 - 2023-04-18 10:00 - CDTS_Test 吴诗雨

- Status changed from RESOLVED to VERIFIED

#13 - 2023-04-18 10:00 - CDTS_Test 吴诗雨

- Status changed from VERIFIED to CLOSED
